$(function() {
 var noOfColumns = 50;
 var noOfRows = 50;
 
  var columnSettings = [{
    headerText: "",
    key: "ProductID",
    hidden: true
  }, {
    headerText: "Product Name",
    key: "ProductName",
    readOnly: true
  }, {
    headerText: "All",
    key: "exclude-all",
    readOnly: false,
    dataType: "bool"
  }];
  
  function onEditCellEnded(evt, ui) {
    data_source[ui.rowID - 1][ui.columnKey] = !ui.value;
    $('#grid1').igGrid("dataBind");
  }

  function init() {
    var data = [];
    for (i = 1; i <= noOfRows; i++) {
      var row = {
        "ProductID": i,
        "ProductName": (new Date()).toISOString(),
        "exclude-all": true
      };
      for (j = 1; j < noOfColumns-2; j++) {
        var key = "Exclude" + j;
        row[key] = true;
		if (i === 1) {
			columnSettings.push({headerText:key,key:key,readOnly:false,dataType: "bool"});
		}
      }
      data.push(row);
    }
    //console.log(data);
    return data;
  }

  var data_source = init();


  $('#grid1').igGrid({
    dataSource: data_source,
    primaryKey: "ProductID",
   // width: "400px",
    height: "400px",
    enableHoverStyles: false,
    autoGenerateColumns: false,
    columns: columnSettings,
    renderCheckboxes: true,
	rowVirtualization: true,
	columnVirtualization: true,
    features: [{
      name: "Filtering",
      allowFiltering: true,
      caseSensitive: false
    }, {
      name: 'Sorting',
      type: "local",
    }, {
      name: "Updating",
      validation: false,
      enableAddRow: false,
      editMode: "cell",
      excelNavigationMode: true,
      enableDeleteRow: false,
      editCellEnded: onEditCellEnded,
      editCellStarted: function() {
        $("#grid1").igGridUpdating("endEdit", true, true);
      }
    }]
  });
});